package codechicken.multipart.handler

import codechicken.multipart.TileMultipart
import cpw.mods.fml.common.eventhandler.SubscribeEvent
import cpw.mods.fml.common.network.FMLNetworkEvent.ServerConnectionFromClientEvent
//import cpw.mods.fml.common.network.IConnectionHandler
//import net.minecraft.network.packet.NetHandler
import net.minecraft.network.NetHandlerPlayServer
//import net.minecraft.network.INetworkManager
//import net.minecraft.network.packet.Packet1Login
//import cpw.mods.fml.common.network.Player
//import net.minecraft.network.NetLoginHandler
import net.minecraft.server.MinecraftServer
import gcewing.codechicken.lib.packet.PacketCustom
import codechicken.multipart.MultiPartRegistry
import net.minecraftforge.event.world._
//import cpw.mods.fml.common.ITickHandler
import cpw.mods.fml.common.gameevent.TickEvent
import cpw.mods.fml.common.gameevent.TickEvent.ServerTickEvent
import java.util.EnumSet
//import cpw.mods.fml.common.TickType
import scala.collection.JavaConverters._
import java.util.List
import net.minecraft.entity.player.EntityPlayerMP
import cpw.mods.fml.common.eventhandler.EventPriority
import cpw.mods.fml.relauncher.SideOnly
import cpw.mods.fml.relauncher.Side
import net.minecraftforge.client.event.DrawBlockHighlightEvent
import net.minecraft.util.MovingObjectPosition.MovingObjectType
import codechicken.multipart.BlockMultipart

object MultipartEventHandler //extends IConnectionHandler with ITickHandler
{
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    def tileEntityLoad(event:ChunkDataEvent.Load)
    {
        MultipartSaveLoad.loadTiles(event.getChunk)
    }
    
    @SubscribeEvent
    def worldUnLoad(event:WorldEvent.Unload)
    {
        MultipartSPH.onWorldUnload(event.world)
    }

    @SubscribeEvent
    def chunkWatch(event:ChunkWatchEvent.Watch)
    {
        MultipartSPH.onChunkWatch(event.player, event.chunk)
    }

    @SubscribeEvent
    def chunkUnWatch(event:ChunkWatchEvent.UnWatch)
    {
        MultipartSPH.onChunkUnWatch(event.player, event.chunk)
    }
    
    @SubscribeEvent
    @SideOnly(Side.CLIENT)
    def drawBlockHighlight(event:DrawBlockHighlightEvent)
    {
        if(event.target != null && event.target.typeOfHit == MovingObjectType.BLOCK && 
            event.player.worldObj.getTileEntity(event.target.blockX, event.target.blockY, event.target.blockZ).isInstanceOf[TileMultipart])
        {
            if(BlockMultipart.drawHighlight(event.player.worldObj, event.player, event.target, event.partialTicks))
                event.setCanceled(true)
        }
    }
    
//    def connectionReceived(loginHandler:NetLoginHandler, netManager:INetworkManager):String = 
    @SubscribeEvent
    def connectionReceived(evt: ServerConnectionFromClientEvent): String =
    {
        val packet = new PacketCustom(MultipartSPH.registryChannel, 1)
        MultiPartRegistry.writeIDMap(packet)
        //netManager.addToSendQueue(packet.toPacket)
        // Can't use packet.sendToPlayer() because player.playerNetServerHandler not yet set
        evt.handler.asInstanceOf[NetHandlerPlayServer].sendPacket(packet.toPacket())
        return null
    }
    
//    def clientLoggedIn(netHandler:NetHandler, netManager:INetworkManager, packet:Packet1Login){}
//    def playerLoggedIn(player:Player, netHandler:NetHandler, netManager:INetworkManager){}
//    def connectionOpened(netHandler:NetHandler, server:String, port:Int, netManager:INetworkManager){}
//    def connectionOpened(netHandler:NetHandler, server:MinecraftServer, netManager:INetworkManager){}
//    def connectionClosed(netManager:INetworkManager){}
    
//    def ticks = EnumSet.of(TickType.SERVER)
    def getLabel = "Multipart"
//    def tickStart(tickType:EnumSet[TickType], data:Object*){}

//    def tickEnd(tickType:EnumSet[TickType], data:Object*)
    @SubscribeEvent
    def tickEnd(evt: ServerTickEvent)
    {
        //Console.printf("MultipartEventHandler.tickEnd phase %s\n", evt.phase);
//        if(tickType.contains(TickType.SERVER))
//        {
        if (evt.phase == TickEvent.Phase.END) {
            MultipartSPH.onTickEnd(
                MinecraftServer.getServer.getConfigurationManager.playerEntityList
                    .asInstanceOf[List[EntityPlayerMP]].asScala)
        }
//        }
    }
}